DirectColorModel

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class DirectColorModel

    java.lang.Object
      java.awt.image.ColorModel
          java.awt.image.DirectColorModel

All Implemented Interfaces:
  Transparency

    public class DirectColorModel

extends ColorModel

The `DirectColorModel` class is a `ColorModel` class that works with pixel values that represent RGB color and alpha information as separate samples and that pack all samples for a single pixel into a single int, short, or byte quantity. This class can be used only with ColorSpaces of type ColorSpace.TYPE_RGB. There must be three color samples in the pixel values and there can be a single alpha sample. For those methods that use a primitive array pixel representation of type `transferType`, the array length is always one. The transfer types supported are DataBuffer.TYPE_BYTE, DataBuffer.TYPE_USHORT, and DataBuffer.TYPE_INT. Color and alpha samples are stored in the single element of the array in bits indicated by bit masks. Each bit mask must be contiguous and masks must not overlap. The same masks apply to the single int pixel representation used by other methods. The correspondence of masks and color/alpha samples is as follows:

- Masks are identified by indices running from 0 through 2 if no alpha is present, or 3 if an alpha is present.
- The first three indices refer to color samples; index 0 corresponds to red, index 1 to green, and index 2 to blue.
- Index 3 corresponds to the alpha sample, if present.

A single int pixel representation is valid for all objects of this class, since it is always possible to represent pixel values used with this class in a single int. Therefore, methods which use this representation will not throw an `IllegalArgumentException` due to an invalid pixel value.

This color model is similar to an X11 TrueColor visual. The default RGB ColorModel specified by the `getRGBdefault` method is a `DirectColorModel` with the following parameters:

     Number of bits:        32
     Red mask:              0x00ff0000
     Green mask:            0x0000ff00
     Blue mask:             0x000000ff
     Alpha mask:            0xff000000
     Color space:           sRGB
     isAlphaPremultiplied:  False
     Transparency:          Transparency.TRANSLUCENT
     transferType:          DataBuffer.TYPE_INT

Many of the methods in this class are final. This is because the underlying native graphics code makes assumptions about the layout and operation of this class and those assumptions are reflected in the implementations of the methods here that are marked final. You can subclass this class for other reasons, but you cannot override or modify the behavior of those methods.

Version:
  10 Feb 1997
See Also:
  `ColorModel`, `ColorSpace`, `BufferedImage`, `ColorModel.getRGBdefault()`

Field Summary

Fields inherited from interface java.awt.Transparency
`BITMASK, OPAQUE, TRANSLUCENT`

Constructor Summary
`DirectColorModel(ColorSpace space, int bits, int rmask, int gmask, int bmask, int amask, boolean isAlphaPremultiplied, int transferType)` Constructs a `DirectColorModel` from the specified parameters.
`DirectColorModel(int bits, int rmask, int gmask, int bmask)` Constructs a `DirectColorModel` from the specified masks that indicate which bits in an `int` pixel representation contain the red, green and blue color samples.
`DirectColorModel(int bits, int rmask, int gmask, int bmask, int amask)` Constructs a `DirectColorModel` from the specified masks that indicate which bits in an `int` pixel representation contain the red, green and blue color samples and the alpha sample, if present.

Method Summary
`int` | `getAlpha(int pixel)` Returns the alpha component for the specified pixel, scaled from 0 to 255.
`int` | `getAlphaMask()` Returns the mask indicating which bits in an `int` pixel representation contain the alpha component.
`int` | `getBlue(int pixel)` Returns the blue color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB.
`int` | `getBlueMask()` Returns the mask indicating which bits in an `int` pixel representation contain the blue color component.
`int` | `getGreen(int pixel)` Returns the green color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB.
`int` | `getGreenMask()` Returns the mask indicating which bits in an `int` pixel representation contain the green color component.
`int` | `getRed(int pixel)` Returns the red color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB.
`int` | `getRedMask()` Returns the mask indicating which bits in an `int` pixel representation contain the red color component.
`int` | `getRGB(int pixel)` Returns the color/alpha components of the pixel in the default RGB color model format.
`String` | `toString()` Returns a `String` that represents this `DirectColorModel`.

Methods inherited from class java.awt.image.ColorModel
`equals, finalize, getColorSpace, getComponentSize, getComponentSize, getNumColorComponents, getNumComponents, getPixelSize, getRGBdefault, getTransferType, getTransparency, hasAlpha, hashCode, isAlphaPremultiplied`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DirectColorModel

    public DirectColorModel(int bits,
                            int rmask,
                            int gmask,
                            int bmask)

  Constructs a `DirectColorModel` from the specified masks that indicate which bits in an `int` pixel representation contain the red, green and blue color samples. As pixel values do not contain alpha information, all pixels are treated as opaque, which means that alpha = 1.0. All of the bits in each mask must be contiguous and fit in the specified number of least significant bits of an `int` pixel representation. The `ColorSpace` is the default sRGB space. The transparency value is Transparency.OPAQUE. The transfer type is the smallest of DataBuffer.TYPE_BYTE, DataBuffer.TYPE_USHORT, or DataBuffer.TYPE_INT that can hold a single pixel.

  Parameters:
    `bits` - the number of bits in the pixel values; for example, the sum of the number of bits in the masks.
    `rmask` - specifies a mask indicating which bits in an integer pixel contain the red component
    `gmask` - specifies a mask indicating which bits in an integer pixel contain the green component
    `bmask` - specifies a mask indicating which bits in an integer pixel contain the blue component

### DirectColorModel

    public DirectColorModel(int bits,
                            int rmask,
                            int gmask,
                            int bmask,
                            int amask)

  Constructs a `DirectColorModel` from the specified masks that indicate which bits in an `int` pixel representation contain the red, green and blue color samples and the alpha sample, if present. If `amask` is 0, pixel values do not contain alpha information and all pixels are treated as opaque, which means that alpha = 1.0. All of the bits in each mask must be contiguous and fit in the specified number of least significant bits of an `int` pixel representation. Alpha, if present, is not premultiplied. The `ColorSpace` is the default sRGB space. The transparency value is Transparency.OPAQUE if no alpha is present, or Transparency.TRANSLUCENT otherwise. The transfer type is the smallest of DataBuffer.TYPE_BYTE, DataBuffer.TYPE_USHORT, or DataBuffer.TYPE_INT that can hold a single pixel.

  Parameters:
    `bits` - the number of bits in the pixel values; for example, the sum of the number of bits in the masks.
    `rmask` - specifies a mask indicating which bits in an integer pixel contain the red component
    `gmask` - specifies a mask indicating which bits in an integer pixel contain the green component
    `bmask` - specifies a mask indicating which bits in an integer pixel contain the blue component
    `amask` - specifies a mask indicating which bits in an integer pixel contain the alpha component

### DirectColorModel

    public DirectColorModel(ColorSpace space,
                            int bits,
                            int rmask,
                            int gmask,
                            int bmask,
                            int amask,
                            boolean isAlphaPremultiplied,
                            int transferType)

  Constructs a `DirectColorModel` from the specified parameters. Color components are in the specified `ColorSpace`, which must be of type ColorSpace.TYPE_RGB and have minimum normalized component values which are all 0.0 and maximum values which are all 1.0. The masks specify which bits in an `int` pixel representation contain the red, green and blue color samples and the alpha sample, if present. If `amask` is 0, pixel values do not contain alpha information and all pixels are treated as opaque, which means that alpha = 1.0. All of the bits in each mask must be contiguous and fit in the specified number of least significant bits of an `int` pixel representation. If there is alpha, the `boolean` `isAlphaPremultiplied` specifies how to interpret color and alpha samples in pixel values. If the `boolean` is `true`, color samples are assumed to have been multiplied by the alpha sample. The transparency value is Transparency.OPAQUE, if no alpha is present, or Transparency.TRANSLUCENT otherwise. The transfer type is the type of primitive array used to represent pixel values and must be one of DataBuffer.TYPE_BYTE, DataBuffer.TYPE_USHORT, or DataBuffer.TYPE_INT.

  Parameters:
    `space` - the specified `ColorSpace`
    `bits` - the number of bits in the pixel values; for example, the sum of the number of bits in the masks.
    `rmask` - specifies a mask indicating which bits in an integer pixel contain the red component
    `gmask` - specifies a mask indicating which bits in an integer pixel contain the green component
    `bmask` - specifies a mask indicating which bits in an integer pixel contain the blue component
    `amask` - specifies a mask indicating which bits in an integer pixel contain the alpha component
    `isAlphaPremultiplied` - `true` if color samples are premultiplied by the alpha sample; `false` otherwise
    `transferType` - the type of array used to represent pixel values
  Throws:
    `IllegalArgumentException` - if `space` is not a TYPE_RGB space or if the min/max normalized component values are not 0.0/1.0.

Method Detail

### getRedMask

    public final int getRedMask()

  Returns the mask indicating which bits in an `int` pixel representation contain the red color component.

  Returns:
    the mask, which indicates which bits of the `int` pixel representation contain the red color sample.

### getGreenMask

    public final int getGreenMask()

  Returns the mask indicating which bits in an `int` pixel representation contain the green color component.

  Returns:
    the mask, which indicates which bits of the `int` pixel representation contain the green color sample.

### getBlueMask

    public final int getBlueMask()

  Returns the mask indicating which bits in an `int` pixel representation contain the blue color component.

  Returns:
    the mask, which indicates which bits of the `int` pixel representation contain the blue color sample.

### getAlphaMask

    public final int getAlphaMask()

  Returns the mask indicating which bits in an `int` pixel representation contain the alpha component.

  Returns:
    the mask, which indicates which bits of the `int` pixel representation contain the alpha sample.

### getRed

    public final int getRed(int pixel)

  Returns the red color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB. A color conversion is done if necessary. The pixel value is specified as an `int`. The returned value is a non pre-multiplied value. Thus, if the alpha is premultiplied, this method divides it out before returning the value. If the alpha value is 0, for example, the red value is 0.

  Specified by:
    `getRed` in class `ColorModel`
  Parameters:
    `pixel` - the specified pixel
  Returns:
    the red color component for the specified pixel, from 0 to 255 in the sRGB `ColorSpace`.

### getGreen

    public final int getGreen(int pixel)

  Returns the green color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB. A color conversion is done if necessary. The pixel value is specified as an `int`. The returned value is a non pre-multiplied value. Thus, if the alpha is premultiplied, this method divides it out before returning the value. If the alpha value is 0, for example, the green value is 0.

  Specified by:
    `getGreen` in class `ColorModel`
  Parameters:
    `pixel` - the specified pixel
  Returns:
    the green color component for the specified pixel, from 0 to 255 in the sRGB `ColorSpace`.

### getBlue

    public final int getBlue(int pixel)

  Returns the blue color component for the specified pixel, scaled from 0 to 255 in the default RGB `ColorSpace`, sRGB. A color conversion is done if necessary. The pixel value is specified as an `int`. The returned value is a non pre-multiplied value. Thus, if the alpha is premultiplied, this method divides it out before returning the value. If the alpha value is 0, for example, the blue value is 0.

  Specified by:
    `getBlue` in class `ColorModel`
  Parameters:
    `pixel` - the specified pixel
  Returns:
    the blue color component for the specified pixel, from 0 to 255 in the sRGB `ColorSpace`.

### getAlpha

    public final int getAlpha(int pixel)

  Returns the alpha component for the specified pixel, scaled from 0 to 255. The pixel value is specified as an `int`.

  Specified by:
    `getAlpha` in class `ColorModel`
  Parameters:
    `pixel` - the specified pixel
  Returns:
    the value of the alpha component of `pixel` from 0 to 255.

### getRGB

    public final int getRGB(int pixel)

  Returns the color/alpha components of the pixel in the default RGB color model format. A color conversion is done if necessary. The pixel value is specified as an `int`. The returned value is in a non pre-multiplied format. Thus, if the alpha is premultiplied, this method divides it out of the color components. If the alpha value is 0, for example, the color values are each 0.

  Overrides:
    `getRGB` in class `ColorModel`
  Parameters:
    `pixel` - the specified pixel
  Returns:
    the RGB value of the color/alpha components of the specified pixel.
  See Also:
    `ColorModel.getRGBdefault()`

### toString

    public String toString()

  Returns a `String` that represents this `DirectColorModel`.

  Overrides:
    `toString` in class `ColorModel`
  Returns:
    a `String` representing this `DirectColorModel`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD